﻿using UnityEngine;
using System.Collections;

public class EnemyScript : MonoBehaviour {
	ShipTypeSwitcherScript switcherScript;
	WaypointWalkerScript waypointWalker;

	private GameControllerScript gameController;

	// Use this for initialization
	void Start () {
		switcherScript = transform.FindChild("ShipTypeSwitcher").gameObject.GetComponent<ShipTypeSwitcherScript>();
		gameController = GameObject.Find("GameController").GetComponent<GameControllerScript>();
		waypointWalker = transform.gameObject.GetComponent<WaypointWalkerScript>();
	}
	
	// Update is called once per frame
	void Update () {

	}

	public void TriggerSeen(PlayerScript player){
		if(switcherScript !=null){
			int shipType = player.shipType;	
			if(switcherScript.GetShipType() != shipType){
				switcherScript.SetShipType(shipType);
				switch(switcherScript.GetShipType()){
				case 0: 
					waypointWalker.movementSpeed = 0.0f;
					break;
				case 1: 
					waypointWalker.movementSpeed = 1.0f;
					break;
				case 2: 
					waypointWalker.movementSpeed = 2.0f;
					break;
				}
			}
		}

	}

	void OnCollisionEnter2D (Collision2D other) {
		if(other.gameObject.tag == "Player"){
			gameController.PlayerKilled();
		}
	}

	public void DestroyEnemy(){
		Destroy(gameObject);
	}
}
