﻿using UnityEngine;
using System.Collections;

public class LaserScript : MonoBehaviour {

	public int laserDirection = 0;

	public Vector3 laserHitPoint;

	private LineRenderer laserBeam;
	private Transform laserPoint;
	private Transform laserEmitter;
	private Transform laserCollider;

	private GameControllerScript gameController;

	// Use this for initialization
	void Start () {
		gameController = GameObject.Find("GameController").GetComponent<GameControllerScript>();

		laserBeam = transform.FindChild("LaserBeam").gameObject.GetComponent<LineRenderer>();
		laserPoint = transform.FindChild("LaserBeamPoint").gameObject.GetComponent<Transform>();
		laserEmitter = transform.FindChild("LaserEmitter").gameObject.GetComponent<Transform>();
		laserCollider = transform.FindChild("LaserPlayerCollider").gameObject.GetComponent<Transform>();
	}
	public float floatHeight;
	public float liftForce;
	public float damping;
	// Update is called once per frame
	void Update () {
		/*
		RaycastHit hit;
		//if ()
	//		float distanceToGround = hit.distance;
		if(Physics2D.Raycast(transform.position., new Vector3(0, 1), out hit, Mathf.Infinity))
			Debug.Log("Hit Something");

		laserHitPoint = hit.point;
		*/

		RaycastHit2D hit = Physics2D.Raycast(laserEmitter.position, laserEmitter.up);

		if (hit != null) {
			if(hit.collider.tag == "Player"){
				Debug.Log("HIT PLAYER");
				gameController.PlayerKilled();
				//hit.collider.gameObject.GetComponent<PlayerScript>
			}
			laserHitPoint = new Vector3(hit.point.x, hit.point.y, 0);
			Vector3 laserColliderMidPoint = transform.InverseTransformPoint(laserHitPoint)/2.0f;
			laserCollider.localPosition = laserColliderMidPoint;
			laserCollider.localScale = new Vector3(0.5f,(laserHitPoint - transform.position).magnitude,1.0f);
			laserBeam.SetPosition(1, transform.InverseTransformPoint(laserHitPoint));
			laserPoint.localPosition =  transform.InverseTransformPoint(laserHitPoint);
		}
	}

	void OnDrawGizmos() {

		Gizmos.color = Color.red;

		Gizmos.DrawLine(transform.position, laserHitPoint);

		Debug.DrawRay(transform.position,  new Vector3(0, 1, 0), Color.blue);
	}

}
