﻿using UnityEngine;
using System.Collections;

public class PlayerScript : MonoBehaviour {

	public Transform point;

	public float movementSpeed = 10.0f;
	public float rotationSpeed = 10.0f;
	public Camera camera;
	public int shipType = 0;

	private Transform orientationObj;

	private float mouseX;
	private float mouseY;
	private bool joystickMode;


	private ShipTypeSwitcherScript switcherScript;

	// Use this for initialization
	void Start () {
		orientationObj = transform.FindChild("Orientation");
		switcherScript = transform.FindChild("Orientation/ShipTypeSwitcher").gameObject.GetComponent<ShipTypeSwitcherScript>();

		switcherScript.SetShipType(0);
	}

	bool flag = false;
	
	// Update is called once per frame
	void FixedUpdate() {

		if(Input.GetKeyUp("e")){
			Debug.Log("KEY");
			shipType += 1;
			shipType = shipType % 3;
			switcherScript.SetShipType(shipType);
		}

		if(Input.GetAxis ("BackKeys") > 0 && !flag){
			shipType += 1;
			shipType = shipType % 3;
			switcherScript.SetShipType(shipType);
			flag = true;
		}else if(Input.GetAxis ("BackKeys") < 0 && !flag){
			shipType -= 1;
			if(shipType < 0)
				shipType = 2;
			switcherScript.SetShipType(shipType);
			flag = true;
		}

		if(flag && Input.GetAxis ("BackKeys") == 0){
			flag = false;
		} 

		float moveVertical = Input.GetAxis ("Vertical") * movementSpeed * Time.deltaTime;	
		float moveHorizontal = Input.GetAxis ("Horizontal") * movementSpeed * Time.deltaTime;

		transform.Translate (moveHorizontal, moveVertical, 0);

		//Check for joystick unput
		if(Input.GetAxis ("Vertical2") != 0 || Input.GetAxis ("Horizontal2") != 0){
			joystickMode = true;
		}


		if(joystickMode){
			orientationObj.Rotate (new Vector3(0,0, (-Input.GetAxis ("Horizontal2")) * rotationSpeed * Time.deltaTime ));
		}else{
			mouseX = Input.mousePosition.x;
			mouseY = Input.mousePosition.y;
			
			Vector3 mousePos = camera.ScreenToWorldPoint(new Vector3(mouseX, mouseY, camera.nearClipPlane));
			Vector3 lookAtPos = new Vector3(mousePos.x, mousePos.y, transform.position.z);
			
			
			float a = lookAtPos.x - transform.position.x;
			float b = lookAtPos.y - transform.position.y;
			
			float angle = - (Mathf.Atan(a/b) * Mathf.Rad2Deg);
			
			if(b < 0)
				angle += 180;

			orientationObj.localEulerAngles = new Vector3(0, 0, angle);
		}


	}

}
