﻿using UnityEngine;
using System.Collections;

public class ShipTypeSwitcherScript : MonoBehaviour {

	public int defaultShipType = 0;

	private ShipTypeScript[] shipTypes = new ShipTypeScript[3];

	private int currentType = -1;
	private int newType = 0;

	// Use this for initialization
	void Start () {
		shipTypes[0] = transform.FindChild("ShipTypeOne").gameObject.GetComponent<ShipTypeScript>();
		shipTypes[1] = transform.FindChild("ShipTypeTwo").gameObject.GetComponent<ShipTypeScript>();
		shipTypes[2] = transform.FindChild("ShipTypeThree").gameObject.GetComponent<ShipTypeScript>();

		newType = defaultShipType;
	}
	
	// Update is called once per frame
	void Update () {
		if(currentType != newType){
			SetShipTypeIntern(newType);		
			currentType = newType;
		}
	}

	private void SetShipTypeIntern(int type){
		DisableAll();
		int newType = 0;
		switch(type){
		case 0:
			newType = 0;
			break;
			
		case 1:
			newType = 1;
			break;
			
		case 2:
			newType = 2;
			break;
			
		default:
			newType = 0;
			break;
		}
		shipTypes[newType].gameObject.SetActive(true);
	}

	public void SetShipType(int type){
		newType = type;
	}

	private void DisableAll(){
		for(int i = 0; i < shipTypes.GetLength(0); i++){
			shipTypes[i].gameObject.SetActive(false);
		}
	}

	public int GetShipType(){
		return currentType;
	}
}
