﻿using UnityEngine;
using System.Collections;

public class ViewCone : MonoBehaviour {
	public Transform enemies;
	public float viewConeAngle = 90.0f;
	LineRenderer lineRenderer; 
	// Use this for initialization
	void Start () {
		lineRenderer = transform.gameObject.GetComponent<LineRenderer>();
	}
	
	// Update is called once per frame
	void Update() {
		Vector3 leftStart = new Vector3(0.0f, 3.0f, 0.0f);
		//lineRenderer.SetPosition(1, transform.InverseTransformPoint(leftStart));
		//lineRenderer.localPosition =  transform.InverseTransformPoint(laserHitPoint);

		Vector3 toEnemy;
		Vector3 upfront = transform.position + transform.rotation*(new Vector3(0,3,0));
		foreach(Transform enemy in enemies){
			//enemy.gameObject; 
			//Gizmos.color = Color.blue;
			toEnemy = enemy.position - transform.position;
			float angleToEnemy = Vector3.Angle(upfront-transform.position,toEnemy);
			//Debug.Log(angleToEnemy);
			if(angleToEnemy < viewConeAngle/2.0f){
				RaycastHit2D hit = Physics2D.Raycast(transform.position + transform.rotation * (new Vector2(0,0.7f)) , toEnemy);
				if (hit != null) {
					if(hit.transform){;
						if(hit.transform.tag == "Enemy"){
							//Gizmos.color = Color.red;
							//Gizmos.DrawLine (transform.position, enemy.position);
							//Debug.Log("I HIT AN ENEMY");
							hit.transform.gameObject.GetComponent<EnemyScript>().TriggerSeen(this.transform.parent.gameObject.GetComponent<PlayerScript>());
						}else{
							//Gizmos.color = Color.blue;
							//Gizmos.DrawLine (transform.position, enemy.position);
							//Debug.Log("I HIT AN ENVIRONMENTS");
						}
						
					}
				}
			}
		}
	}

	void OnDrawGizmos () {
		// Draws a blue line from this transform to the target
		if(this.gameObject != null){
			Vector3 target = transform.position + this.gameObject.transform.rotation*(new Vector3(3,3,0));
			Gizmos.color = Color.yellow;
			Gizmos.DrawLine (transform.position, target);
			Vector3 target2 = transform.position + this.gameObject.transform.rotation*(new Vector3(-3,3,0));
			Gizmos.DrawLine (transform.position, target2);
		}

		Gizmos.color = Color.red;
		Vector3 upfront = transform.position + transform.rotation*(new Vector3(0,3,0));
		Gizmos.DrawLine (transform.position, upfront);
		Vector3 toEnemy;
		foreach(Transform enemy in enemies){
			//enemy.gameObject; 
			//Gizmos.color = Color.blue;
			toEnemy = enemy.position - transform.position;
			float angleToEnemy = Vector3.Angle(upfront-transform.position,toEnemy);
			//Debug.Log(angleToEnemy);
			if(angleToEnemy < viewConeAngle/2.0f){
				RaycastHit2D hit = Physics2D.Raycast(transform.position + transform.rotation * (new Vector2(0,0.7f)) , toEnemy);
				if (hit != null) {
					if(hit.transform){;
						if(hit.transform.tag == "Enemy"){
							Gizmos.color = Color.red;
							Gizmos.DrawLine (transform.position, enemy.position);


						}else{
							Gizmos.color = Color.blue;
							Gizmos.DrawLine (transform.position, enemy.position);

						}
						
					}
				}
			}else{
				Gizmos.color = Color.cyan;
				Gizmos.DrawLine (transform.position, enemy.position);
			}
		}

	}
}
